Difference between revisions of "Draft Draft2Sketch/hr"

From FreeCAD Documentation
Jump to navigation Jump to search
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(13 intermediate revisions by the same user not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
{{Docnav|[[Draft_Shape2DView|Shape 2D View]]|[[Draft_Array|Array]]|[[Draft_Module|Draft]]|IconL=Draft_Shape2DView.svg|IconC=Workbench_Draft.svg|IconR=Draft_Array.svg}}
+
 
 +
{{Docnav
 +
|[[Draft_WireToBSpline|WireToBSpline]]
 +
|[[Draft_Slope|Slope]]
 +
|[[Draft_Workbench|Draft]]
 +
|IconL=Draft_WireToBSpline.svg
 +
|IconR=Draft_Slope.svg
 +
|IconC=Workbench_Draft.svg
 +
}}
  
 
{{GuiCommand
 
{{GuiCommand
 
|Name=Draft Draft2Sketch
 
|Name=Draft Draft2Sketch
|MenuLocation=Draft → Draft to Sketch
+
|MenuLocation=Modification → Draft to Sketch
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
+
|Workbenches=[[Draft_Workbench|Draft]], [[Arch_Workbench|Arch]]
|SeeAlso=[[Sketcher Workbench]], [[PartDesign Workbench]]
 
 
}}
 
}}
  
==Description==
+
==Description==  
This tool converts [[Draft Module|Draft objects]] to [[Sketcher Module|Sketcher Sketches]], and vice-versa.
+
 
 +
The [[Image:Draft_Draft2Sketch.svg|24px]] '''Draft Draft2Sketch''' command converts [[Draft_Workbench|Draft]] objects to [[Sketcher_NewSketch|Sketcher Sketches]] and vice versa.
 +
 
 +
[[Image:Draft_Draft2Sketch_example.png]]
 +
{{Caption|Converting Draft objects to Sketcher Sketches}}
  
[[Image:Draft Draft2Sketch example.jpg||480px]]
+
==Usage==
{{Caption|Converting Draft shapes into Sketcher shapes with constraints}}
 
  
==How to use==
+
# Optionally select one or more Draft objects or [[Sketcher_NewSketch|Sketcher Sketches]].
# Select a Draft object or a Sketch.
+
# There are several ways to invoke the command:
# Press the {{Button|[[Image:Draft Draft2Sketch.svg|16px]] [[Draft Draft2Sketch]]}} button.
+
#* Press the {{Button|[[Image:Draft_Draft2Sketch.svg|16px]] [[Draft_Draft2Sketch|Draft Draft2Sketch]]}} button.
 +
#* Select the {{MenuCommand|Modification → [[Image:Draft_Draft2Sketch.svg|16px]] Draft to Sketch}} option from the menu.
 +
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].
 +
# A new object is created.
  
Notes:
+
==Notes==
* If you convert a [[Draft Wire]], the resulting sketch will use point constraints for the nodes.
 
* If you convert a [[Draft Rectangle]], the resulting sketch will use point constraints for the corners, and horizontal and vertical constraints for the edges.
 
* If you convert a [[Draft BezCurve]], the resulting sketch will be approximated by a [[Sketcher CreateBSpline|Sketcher BSpline]], as the [[Sketcher Workbench]] doesn't support Bezier curves currently.
 
* Non-Draft objects that are totally planar will also get converted to sketches.
 
  
===Limitations===
+
* Non-Draft objects that are totally planar can also be converted.
The conversion of an object that cannot be represented with a combination of straight lines, circular arcs, and B-Splines will usually fail, that is, the item will not appear in the sketch.
+
* The command can only handle objects made up out of straight lines, circular arcs, elliptical arcs, B-Splines and Bézier curves.
 +
* [[Draft_BezCurve|Draft BezCurves]] will be approximated by [[Sketcher_CreateBSpline|Sketcher BSplines]].
 +
* The external [[KicadStepUp_Workbench|KicadStepUp Workbench]] contains a command to convert a [[Draft_BSpline|Draft BSpline]] into a series of [[Sketcher_CreateArc|Sketcher Arcs]]. For more information see the forum topic [https://forum.freecadweb.org/viewtopic.php?f=9&t=25082 BSplines to Shape2DView and Sketcher].
 +
* [https://forum.freecadweb.org/viewtopic.php?f=3&t=58781#p505207 This other forum topic] contains a macro for such a conversion.
  
In the past, a [[Draft BSpline]] couldn't be converted directly to a sketch. A tool to perform this conversion was developed for the [[KicadStepUp Workbench]], which would take a [[Draft BSpline]] and convert it into a series of [[Sketcher CreateArc|Sketcher Arcs]]. See the forum thread [https://forum.freecadweb.org/viewtopic.php?f=9&t=25082 BSplines to Shape2DView and Sketcher] for more information.
+
==Scripting==
  
Since FreeCAD 0.17, the conversion from [[Draft BSpline]] to [[Sketcher CreateBSpline|Sketcher BSpline]] is possible. However, converting a spline to a series of arcs may still be useful for exporting geometry to applications that don't support B-Splines, like KiCad.
+
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
  
==Opcije==
+
To convert objects to a sketch use the {{incode|make_sketch}} method ({{Version|0.19}}) of the Draft module. This method replaces the deprecated {{incode|makeSketch}} method.
  
There are no options for this tool. Either it works with the selected object or not.
+
{{Code|code=
 +
sketch = make_sketch(objects_list, autoconstraints=False, addTo=None, delete=False, name="Sketch", radiusPrecision=-1, tol=1e-3)
 +
}}
  
==Scripting==
+
* {{incode|objects_list}} contains the objects to be converted. It is either a single object or a list of objects. {{incode|Draft}} objects, {{incode|Part::Feature}} objects and {{incode|Part.Shape}} objects are supported.
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].
+
* If {{incode|autoconstraints}} is {{incode|True}} coincident constraints are added to nodes belonging to the same source object.
 +
* {{incode|addTo}} is the existing sketch object the geometry is added to. If not supplied a new sketch is created.
 +
* If {{incode|delete}} is {{incode|True}} the source objects are deleted.
 +
* {{incode|name}} is the name for the new sketch.
 +
* {{incode|radiusPrecision}} indicates how radius constraints should be handled:
 +
** Use {{incode|-1}} to disable radius constraints.
 +
** Use {{incode|0}} to add individual radius constraints.
 +
** Use a positive number to round radii according to this precision, and to add equal constraints between curves with equal radii.
 +
* {{incode|tol}} is the tolerance used to check if shapes are planar and co-planar. Use {{incode|-1}} for a strict analysis.
 +
* {{incode|sketch}} is returned with the sketch object.
  
Internally the Draft2Sketch tool uses two methods to convert back and forth from Draft to Sketch.
+
To convert a sketch to Draft objects use the {{incode|draftify}} method of the Draft module.
  
Convert objects to Sketch:
 
 
{{Code|code=
 
{{Code|code=
Draft.makeSketch(objectslist, autoconstraints=False, addTo=None, delete=False, name="Sketch", radiusPrecision=-1)
+
draftify(objectslist, makeblock=False, delete=True)
 
}}
 
}}
  
Convert objects to Draft:
+
* {{incode|objectslist}} contains the objects to be converted. It is either a single object or a list of objects.
 +
* If {{incode|makeblock}} is {{incode|True}} the converted objects are grouped in a {{incode|Part::Part2DObject}}.
 +
* If {{incode|delete}} is {{incode|True}} the source objects are deleted.
 +
 
 +
Example:
 +
 
 
{{Code|code=
 
{{Code|code=
Draft.draftify(objectslist, makeblock=False, delete=True)
+
import FreeCAD as App
 +
import Draft
 +
 
 +
doc = App.newDocument()
 +
 
 +
rectangle = Draft.make_rectangle(2000, 1000)
 +
circle = Draft.make_circle(500)
 +
doc.recompute()
 +
 
 +
sketch_from_draft = Draft.make_sketch([rectangle, circle], autoconstraints=True, delete=False, radiusPrecision=0)
 +
doc.recompute()
 +
 
 +
draft_from_sketch = Draft.draftify(sketch_from_draft, delete=False)
 +
doc.recompute()
 
}}
 
}}
  
{{Docnav|[[Draft_Shape2DView|Shape 2D View]]|[[Draft_Array|Array]]|[[Draft_Module|Draft]]|IconL=Draft_Shape2DView.svg|IconC=Workbench_Draft.svg|IconR=Draft_Array.svg}}
 
  
{{Draft Tools navi}}
+
{{Docnav
 +
|[[Draft_WireToBSpline|WireToBSpline]]
 +
|[[Draft_Slope|Slope]]
 +
|[[Draft_Workbench|Draft]]
 +
|IconL=Draft_WireToBSpline.svg
 +
|IconR=Draft_Slope.svg
 +
|IconC=Workbench_Draft.svg
 +
}}
  
{{Userdocnavi}}
+
{{Draft Tools navi{{#translation:}}}}
{{clear}}
+
{{Userdocnavi{{#translation:}}}}

Latest revision as of 09:39, 22 September 2021

Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎hrvatski • ‎italiano • ‎polski • ‎português do Brasil • ‎română • ‎svenska • ‎čeština • ‎русский
Arrow-left.svg Previous: Draft WireToBSpline.svg WireToBSpline
Next: Slope Draft Slope.svg Arrow-right.svg

Draft Draft2Sketch.svg Draft Draft2Sketch

Menu location
Modification → Draft to Sketch
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
None

Description

The Draft Draft2Sketch.svg Draft Draft2Sketch command converts Draft objects to Sketcher Sketches and vice versa.

Draft Draft2Sketch example.png

Converting Draft objects to Sketcher Sketches

Usage

  1. Optionally select one or more Draft objects or Sketcher Sketches.
  2. There are several ways to invoke the command:
    • Press the Draft Draft2Sketch.svg Draft Draft2Sketch button.
    • Select the Modification → Draft Draft2Sketch.svg Draft to Sketch option from the menu.
  3. If you have not yet selected an object: select an object in the 3D view.
  4. A new object is created.

Notes

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To convert objects to a sketch use the make_sketch method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeSketch method.

sketch = make_sketch(objects_list, autoconstraints=False, addTo=None, delete=False, name="Sketch", radiusPrecision=-1, tol=1e-3)
  • objects_list contains the objects to be converted. It is either a single object or a list of objects. Draft objects, Part::Feature objects and Part.Shape objects are supported.
  • If autoconstraints is True coincident constraints are added to nodes belonging to the same source object.
  • addTo is the existing sketch object the geometry is added to. If not supplied a new sketch is created.
  • If delete is True the source objects are deleted.
  • name is the name for the new sketch.
  • radiusPrecision indicates how radius constraints should be handled:
    • Use -1 to disable radius constraints.
    • Use 0 to add individual radius constraints.
    • Use a positive number to round radii according to this precision, and to add equal constraints between curves with equal radii.
  • tol is the tolerance used to check if shapes are planar and co-planar. Use -1 for a strict analysis.
  • sketch is returned with the sketch object.

To convert a sketch to Draft objects use the draftify method of the Draft module.

draftify(objectslist, makeblock=False, delete=True)
  • objectslist contains the objects to be converted. It is either a single object or a list of objects.
  • If makeblock is True the converted objects are grouped in a Part::Part2DObject.
  • If delete is True the source objects are deleted.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rectangle = Draft.make_rectangle(2000, 1000)
circle = Draft.make_circle(500)
doc.recompute()

sketch_from_draft = Draft.make_sketch([rectangle, circle], autoconstraints=True, delete=False, radiusPrecision=0)
doc.recompute()

draft_from_sketch = Draft.draftify(sketch_from_draft, delete=False)
doc.recompute()


Arrow-left.svg Previous: Draft WireToBSpline.svg WireToBSpline
Next: Slope Draft Slope.svg Arrow-right.svg